Attribute VB_Name = "Module1"
Option Explicit


Type Point2D
    X As Single
    Y As Single
End Type

Type Point3D
    X As Single
    Y As Single
    Z As Single
End Type

Type Line2D
    X1 As Single
    Y1 As Single
    X2 As Single
    Y2 As Single
End Type

Type Polygon
    NumVerts As Integer
    Verts(50) As Integer
    FaceN As Point3D    'The face normal of the polygon
    MidPt As Point3D
    NEndPt As Point3D
    TextureIndex As Integer
End Type

Type Light
    X1 As Single
    Y1 As Single
    Z1 As Single
    X2 As Single
    Y2 As Single
    Z2 As Single
    Radius1 As Single
    Radius2 As Single
    Brightness As Single
    R As Single
    G As Single
    B As Single
    LightType As Integer
End Type

Type Water
    Y As Single
    NumBoundingPolys As Integer
    BoundingPolys(50) As Integer
    R As Single
    G As Single
    B As Single
End Type

Type TexProperty
    TexName As String
    HasAlpha As Integer
    Glass As Integer
    Reflective As Single
    Animated As Integer
    AnimT1 As Single
    AnimT2 As Single
    Energy As Integer
    HitChecked As Integer
End Type

'-- The Texture Table ----'
Public NumTex As Integer
Public TexProp(100) As TexProperty
Public SelectedItems(100) As Boolean

'----- The texture file names -------'
Public NumTextures As Integer
Public TextureFileNames(500) As String


'-----The Lights-----------'
Public NumRoomLights As Integer
Public RoomLights(1000) As Light

'-----The Waters-----------'
Public NumRoomWaters As Integer
Public RoomWaters(1000) As Water


'---- Object Points -------'
Public NumPts As Integer
Public Pts(10000) As Point3D
Public MidPt As Point3D
Public ScrnPts(10000) As Point2D  'The Object's Screen Points

'---- Object Polygons -------'
Public NumPoly As Integer
Public Poly(10000) As Polygon
Public ScrnFN(10000) As Line2D
Public FrontFacing(10000) As Boolean


'---- The Object's texture coordinates ----'
Public Tex(10000) As Point2D


'---- Some values ----------'
Public NumEPts As Integer
Public NumEPoly As Integer
Public NumETextures As Integer
Public NumERoomLights As Integer
Public NumERoomWaters As Integer

Public rX1, rY1, rZ1, rX2, rY2, rZ2 As Single
Public SelectedPts(10000) As Boolean
Public SelectedPoly(10000) As Boolean
Public SelectedLights(1000) As Boolean
Public SelectedWaters(1000) As Boolean
Public cos1, sin1 As Single
Public cos2, sin2 As Single
Public Magnification As Single
Public XDisp, YDisp As Single
Public PtsFilter As Integer
Public PolyFilter As Integer
Public VNFilter As Integer
Public CullMode As Integer
Public CullDum As Single
Public Maxpolystrlen As Integer
Public SPtsP(50) As Integer
Public NumSPtsP As Integer
Public DummyB As Boolean

Public Sub RefreshPointList()
Dim i As Integer

Form1.List1.Clear

For i = 0 To NumPts - 1
    Form1.List1.AddItem i & ".)(" & Format(Pts(i).X, "0.0#") & "," & Format(Pts(i).Y, "0.0#") & "," & Format(Pts(i).Z, "0.0#") & ")"
Next

End Sub

Public Sub RefreshPolyList()
Dim i, j As Integer
Dim tstr As String

Form1.List2.Clear

For i = 0 To NumPoly - 1
    tstr = ""
    For j = 0 To Poly(i).NumVerts - 1
        tstr = tstr & Poly(i).Verts(j) & ","
    Next
    tstr = i & ".)(" & Left(tstr, Len(tstr) - 1) & ")"
    Form1.List2.AddItem tstr
Next

End Sub

Public Sub RefreshLightList()
Dim i As Integer

Form3.List1.Clear

For i = 0 To NumRoomLights - 1

    If RoomLights(i).X2 Or RoomLights(i).Y2 Or RoomLights(i).Z2 Then
        Form3.List1.AddItem Str(i) + ".) Spot  Light"
    Else
        Form3.List1.AddItem Str(i) + ".) Point Light"
    End If
    
Next

End Sub

Public Sub RefreshWaterList()
Dim i As Integer

Form6.List1.Clear

For i = 0 To NumRoomWaters - 1
    Form6.List1.AddItem Str(i) + ".) Water (" + Format(RoomWaters(i).Y) + ")"
Next

End Sub

Public Sub RefreshText6()
Dim i As Integer

If NumSPtsP = 0 Then Exit Sub
Form1.Text6.Text = "(" & SPtsP(0)
For i = 1 To NumSPtsP - 1
    Form1.Text6.Text = Form1.Text6.Text & "," & SPtsP(i)
Next
Form1.Text6.Text = Form1.Text6.Text & ")"

End Sub

Public Sub DrawObj()
Dim i As Integer, j As Integer, k As Integer
Dim fDum As Single
Dim rPt1 As Point3D
Dim rPt2 As Point3D
Dim LPt As Light

' Clear the previous image
Form1.Picture1.Line (0, 0)-(401, 401), 0, BF


'--------------- Draw the Room's lights ----------------'

'---- Convert the light's 3D coordinates to 2D coordinates -----'
For i = 0 To NumRoomLights - 1

    LPt = RoomLights(i)

    ' Convert the first Point
    rPt1.X = (LPt.X1 - MidPt.X) * cos1 - (LPt.Z1 - MidPt.Z) * sin1
    rPt1.Y = LPt.Y1 - MidPt.Y
    rPt1.Z = (LPt.Z1 - MidPt.Z) * cos1 + (LPt.X1 - MidPt.X) * sin1
    
    rPt2.X = rPt1.X + XDisp
    rPt2.Y = (rPt1.Y) * cos2 + (rPt1.Z) * sin2 + YDisp
    rPt2.Z = (rPt1.Z) * cos2 - (rPt1.Y) * sin2 + 10000
    
    fDum = Magnification / rPt2.Z
    ScrnPts(i).X = rPt2.X * fDum + 200
    ScrnPts(i).Y = 200 - rPt2.Y * fDum
    
    ' Is this a spot light ?
    If LPt.X2 Or LPt.Y2 Or LPt.Z2 Then
        
        ' Convert the second Point
        rPt1.X = (LPt.X2 - MidPt.X) * cos1 - (LPt.Z2 - MidPt.Z) * sin1
        rPt1.Y = LPt.Y2 - MidPt.Y
        rPt1.Z = (LPt.Z2 - MidPt.Z) * cos1 + (LPt.X2 - MidPt.X) * sin1
    
        rPt2.X = rPt1.X + XDisp
        rPt2.Y = (rPt1.Y) * cos2 + (rPt1.Z) * sin2 + YDisp
        rPt2.Z = (rPt1.Z) * cos2 - (rPt1.Y) * sin2 + 10000
    
        fDum = Magnification / rPt2.Z
        ScrnPts(100 + i).X = rPt2.X * fDum + 200
        ScrnPts(100 + i).Y = 200 - rPt2.Y * fDum
    End If

Next

'------ Draw the selected lights ------------'
Form1.Picture1.FillColor = QBColor(10)
For i = 0 To NumRoomLights - 1
    If Form3.List1.Selected(i) = True Then
        Form1.Picture1.Circle (ScrnPts(i).X, ScrnPts(i).Y), 5, QBColor(10)
        If RoomLights(i).X2 Or RoomLights(i).Y2 Or RoomLights(i).Z2 Then
            Form1.Picture1.Line (ScrnPts(i).X, ScrnPts(i).Y)-(ScrnPts(100 + i).X, ScrnPts(100 + i).Y), QBColor(10)
        End If
    End If
Next

'------ Draw the non-selected lights ------------'
Form1.Picture1.FillColor = QBColor(10)
For i = 0 To NumRoomLights - 1
    If Form3.List1.Selected(i) = False Then
        Form1.Picture1.Circle (ScrnPts(i).X, ScrnPts(i).Y), 4, QBColor(10)
        If RoomLights(i).X2 Or RoomLights(i).Y2 Or RoomLights(i).Z2 Then
            Form1.Picture1.Line (ScrnPts(i).X, ScrnPts(i).Y)-(ScrnPts(100 + i).X, ScrnPts(100 + i).Y), QBColor(10)
        End If
    End If
Next


' If there are no points to draw, then exit
If NumPts = 0 Then Exit Sub

'---- Draw the mid-point -----'
fDum = Magnification / 10000
ScrnPts(0).X = XDisp * fDum + 200
ScrnPts(0).Y = 200 - YDisp * fDum

Form1.Picture1.FillColor = QBColor(11)
Form1.Picture1.Circle (ScrnPts(0).X, ScrnPts(0).Y), 4, QBColor(11)


'---- Convert the points' 3D coordinates to 2D coordinates -----'
For i = 0 To NumPts - 1

    rPt1.X = (Pts(i).X - MidPt.X) * cos1 - (Pts(i).Z - MidPt.Z) * sin1
    rPt1.Y = Pts(i).Y - MidPt.Y
    rPt1.Z = (Pts(i).Z - MidPt.Z) * cos1 + (Pts(i).X - MidPt.X) * sin1
    
    rPt2.X = rPt1.X + XDisp
    rPt2.Y = (rPt1.Y) * cos2 + (rPt1.Z) * sin2 + YDisp
    rPt2.Z = (rPt1.Z) * cos2 - (rPt1.Y) * sin2 + 10000
    
    fDum = Magnification / rPt2.Z
    ScrnPts(i).X = rPt2.X * fDum + 200
    ScrnPts(i).Y = 200 - rPt2.Y * fDum
Next


'----- Convert the polygon's face normals to 2D coords
For i = 0 To NumPoly - 1
    
    rPt1.X = (Poly(i).MidPt.X - MidPt.X) * cos1 - (Poly(i).MidPt.Z - MidPt.Z) * sin1
    rPt1.Y = Poly(i).MidPt.Y - MidPt.Y
    rPt1.Z = (Poly(i).MidPt.Z - MidPt.Z) * cos1 + (Poly(i).MidPt.X - MidPt.X) * sin1
    
    rPt2.X = rPt1.X + XDisp
    rPt2.Y = (rPt1.Y) * cos2 + (rPt1.Z) * sin2 + YDisp
    CullDum = (rPt1.Z) * cos2 - (rPt1.Y) * sin2 + 10000
    
    fDum = Magnification / CullDum
    ScrnFN(i).X1 = rPt2.X * fDum + 200
    ScrnFN(i).Y1 = 200 - rPt2.Y * fDum
    
        
    rPt1.X = (Poly(i).NEndPt.X - MidPt.X) * cos1 - (Poly(i).NEndPt.Z - MidPt.Z) * sin1
    rPt1.Y = Poly(i).NEndPt.Y - MidPt.Y
    rPt1.Z = (Poly(i).NEndPt.Z - MidPt.Z) * cos1 + (Poly(i).NEndPt.X - MidPt.X) * sin1
    
    rPt2.X = rPt1.X + XDisp
    rPt2.Y = (rPt1.Y) * cos2 + (rPt1.Z) * sin2 + YDisp
    rPt2.Z = (rPt1.Z) * cos2 - (rPt1.Y) * sin2 + 10000

    fDum = Magnification / rPt2.Z
    ScrnFN(i).X2 = rPt2.X * fDum + 200
    ScrnFN(i).Y2 = 200 - rPt2.Y * fDum


    If (rPt2.Z < CullDum) Then
        FrontFacing(i) = True
    Else
        FrontFacing(i) = False
    End If

Next


'------ Draw the polygons ---------'
If PolyFilter < 2 Then

  If PolyFilter = 0 Then
    For i = 0 To NumPoly - 1
     If CullMode = 0 Or (CullMode = 1 And FrontFacing(i) = True) Or (CullMode = 2 And FrontFacing(i) = False) Then
      If Form1.List2.Selected(i) = False Then
       
        '--- Draw the polygon ------'
        Form1.Picture1.Line (ScrnPts(Poly(i).Verts(Poly(i).NumVerts - 1)).X, ScrnPts(Poly(i).Verts(Poly(i).NumVerts - 1)).Y)-(ScrnPts(Poly(i).Verts(0)).X, ScrnPts(Poly(i).Verts(0)).Y)
        For j = 1 To Poly(i).NumVerts - 1
            Form1.Picture1.Line -(ScrnPts(Poly(i).Verts(j)).X, ScrnPts(Poly(i).Verts(j)).Y)
        Next
       
      End If
     End If
    Next
  End If
    
    For i = 0 To NumPoly - 1
    If Form1.List2.Selected(i) = True Then
        '--- Draw the polygon ------'
        Form1.Picture1.Line (ScrnPts(Poly(i).Verts(Poly(i).NumVerts - 1)).X, ScrnPts(Poly(i).Verts(Poly(i).NumVerts - 1)).Y)-(ScrnPts(Poly(i).Verts(0)).X, ScrnPts(Poly(i).Verts(0)).Y), QBColor(12)
        For j = 1 To Poly(i).NumVerts - 1
            Form1.Picture1.Line -(ScrnPts(Poly(i).Verts(j)).X, ScrnPts(Poly(i).Verts(j)).Y), QBColor(12)
        Next

    End If
    Next
    
End If


'--- Draw the waters --------------'
Dim PI As Integer
For i = 0 To NumRoomWaters - 1
    If Form6.List1.Selected(i) = True Then
    '--- Draw the bounded polygons ------'
        For j = 0 To RoomWaters(i).NumBoundingPolys - 1
            PI = RoomWaters(i).BoundingPolys(j)
            'Draw the poly with index PI
            Form1.Picture1.Line (ScrnPts(Poly(PI).Verts(Poly(PI).NumVerts - 1)).X, ScrnPts(Poly(PI).Verts(Poly(PI).NumVerts - 1)).Y)-(ScrnPts(Poly(PI).Verts(0)).X, ScrnPts(Poly(PI).Verts(0)).Y), QBColor(9)
            For k = 1 To Poly(PI).NumVerts - 1
                Form1.Picture1.Line -(ScrnPts(Poly(PI).Verts(k)).X, ScrnPts(Poly(PI).Verts(k)).Y), QBColor(9)
            Next
        Next
    End If
Next



'----- Draw the polygon's Face normals ------'
If VNFilter < 2 Then

  If VNFilter = 0 Then
    For i = 0 To NumPoly - 1
     If CullMode = 0 Or (CullMode = 1 And FrontFacing(i) = True) Or (CullMode = 2 And FrontFacing(i) = False) Then
      If Form1.List2.Selected(i) = False Then
      
        Form1.Picture1.Line (ScrnFN(i).X1, ScrnFN(i).Y1)-(ScrnFN(i).X2, ScrnFN(i).Y2), QBColor(11)
      
      End If
     End If
    Next
  End If
  
  For i = 0 To NumPoly - 1
      If Form1.List2.Selected(i) Then
        Form1.Picture1.Line (ScrnFN(i).X1, ScrnFN(i).Y1)-(ScrnFN(i).X2, ScrnFN(i).Y2), QBColor(12)
      End If
  Next

End If


'------ Draw the points ------------'
If PtsFilter < 2 Then
    Form1.Picture1.FillColor = QBColor(14)
    For i = 0 To NumPts - 1
        If Form1.List1.Selected(i) = True Then
            Form1.Picture1.Circle (ScrnPts(i).X, ScrnPts(i).Y), 2, QBColor(14)
        End If
    Next
    
    If PtsFilter = 0 Then
        Form1.Picture1.FillColor = QBColor(15)
        For i = 0 To NumPts - 1
            If Form1.List1.Selected(i) = False Then
                Form1.Picture1.Circle (ScrnPts(i).X, ScrnPts(i).Y), 1, QBColor(15)
            End If
        Next
    End If
End If

End Sub

